<?xml version="1.0"?>

<st-source>
<!-- Changes in change set dolphin-compat3 -->
<time-stamp>From VisualWorks® NonCommercial, Release 5i.2 of July 14, 2000 on December 9, 2000 at 7:10:21 am</time-stamp>


<class>
<name>Presenter</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>events parentPresenter </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>ShellView</name>
<environment>Smalltalk</environment>
<super>UI.ApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>shell </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>Shell</name>
<environment>Smalltalk</environment>
<super>Presenter</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>presenters uibuilder </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>RichTextPresenter</name>
<environment>Smalltalk</environment>
<super>Presenter</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>Pretender</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>answers </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<methods>
<class-id>Core.Object</class-id> <category>event accessing</category>

<body><B>removeEventsTriggeredFor: anObject 
	</B>"Dolphin has a different name for this method."

	self removeAllActionsWithReceiver: anObject</body>
</methods>

<methods>
<class-id>Core.Object</class-id> <category>event triggering</category>

<body><B>trigger: event 
	</B>"Dolphin has a different name for this method."

	^self triggerEvent: event</body>

<body><B>trigger: event with: argument 
	</B>"Dolphin has a different name for this method."

	^self triggerEvent: event with: argument</body>

<body><B>trigger: event with: firstArgument with: secondArgument 
	</B>"Dolphin has a different name for this method."

	^self
		triggerEvent: event
		with: firstArgument
		with: secondArgument</body>

<body><B>trigger: event withArguments: argumentList 
	</B>"Dolphin has a different name for this method."

	^self triggerEvent: event withArguments: argumentList</body>
</methods>


<methods>
<class-id>Q</class-id> <category>VW</category>

<body>assert: aBlock
	aBlock value ifFalse: [self error: 'Assertion failed']</body>

<body><B>displayString
	</B>"Dolphin assumes #displayString defined based on #displayOn: and not on #printString."

	| aStream |
	aStream := WriteStream on: (String new: 16).
	self displayOn: aStream.
	^aStream contents</body>

<body><B>myEventTable
	</B>"VW has a different name for this method."

	^self getEvents</body>

<body><B>myEventTable: collection 
	</B>"VW has a different name for this method."

	self setEvents: collection</body>

<body><B>trigger: event 
	</B>^self triggerEvent: event</body>
</methods>


<reorganize>
<class-id>Q</class-id> <organization>('events' #getEvents #nilEventsDuring: #setEvents:)
('initialization' #initialize)
('VW' #assert: #displayString #myEventTable #myEventTable: #trigger:)
</organization>
</reorganize>

<reorganize>
<class-id>QSmalltalkClassLibrary class</class-id> <organization></organization>
</reorganize>

<methods>
<class-id>Core.Stream</class-id> <category>printing</category>

<body><B>display: anObject 
	</B>"Have anObject print on the receiver."

	self nextPutAll: anObject displayString</body>
</methods>


<methods>
<class-id>Core.Integer class</class-id> <category>instance creation</category>

<body><B>fromString: aString 
	</B>"Dolphin has a different name for this method."

	^self readFromString: aString</body>
</methods>


<methods>
<class-id>Presenter class</class-id> <category>defaults</category>

<body><B>defaultModel
	</B>"Answer the default model for instances of the receiver."

	^nil</body>

<body><B>defaultView
	</B>"Answer the name of the default view for instances of the receiver."

	^'Default view'</body>
</methods>

<methods>
<class-id>Presenter class</class-id> <category>instance creation</category>

<body><B>new
	</B>^super new initialize</body>
</methods>

<methods>
<class-id>Presenter class</class-id> <category>VW</category>

<body><B>eventsTriggered
	</B>^#(#closeRequested:)</body>
</methods>

<methods>
<class-id>Presenter</class-id> <category>accessing</category>

<body><B>parentPresenter
	</B>^parentPresenter</body>

<body><B>parentPresenter: aPresenter 
	</B>parentPresenter := aPresenter</body>
</methods>

<methods>
<class-id>Presenter</class-id> <category>initialization</category>

<body><B>createComponents
</B>	"Make named presenters known to the receiver."</body>

<body><B>createSchematicWiring
	</B>"Connect other presenters to the receiver."</body>

<body>initialize</body>
</methods>

<methods>
<class-id>Presenter</class-id> <category>VW</category>

<body><B>myEventTable
	</B>^events</body>

<body><B>myEventTable: collection 
	</B>events := collection</body>

<body><B>myShell
	</B>^self parentPresenter myShell</body>

<body><B>vwWidget
	</B>^self myShell widgetFor: self</body>
</methods>


<methods>
<class-id>Core.Float class</class-id> <category>instance creation</category>

<body><B>fromString: aString 
	</B>"Dolphin has a different name for this method."

	^self readFromString: aString</body>
</methods>


<reorganize>
<class-id>Core.Float class</class-id> <organization>('class initialization' #initialize)
('constants access' #exponentCharacter #pi #radiansPerDegree #unity #zero)
('private' #coerce:to:precision:exponent:exponentChar:)
('external accessing' #baseCType)
('instance creation' #fromString:)
</organization>
</reorganize>

<methods>
<class-id>Kernel.BlockClosure</class-id> <category>exception handling</category>

<body><B>on: exceptionSelector1 do: block1 on: exceptionSelector2 do: block2 
	</B>^[self on: exceptionSelector1 do: block1]
		on: exceptionSelector2 do: block2</body>
</methods>


<methods>
<class-id>Core.Collection</class-id> <category>testing</category>

<body><B>allSatisfy: aBlock 
	</B>self do: [:each | (aBlock value: each)<B> </B>ifFalse: [^false]].
	^true</body>
</methods>


<methods>
<class-id>Core.CharacterArray</class-id> <category>converting</category>

<body><B>subStrings
	</B>"'one  two three' subStrings"

	^((self tokensBasedOn: Character space) reject: [:each | each isEmpty]) asArray</body>
</methods>


<methods>
<class-id>ShellView class</class-id> <category>VW</category>

<body><B>instanceFor: aShell 
	</B>"Answer a new instance of the receiver initialized for aShell."

	^self new setShell: aShell</body>

<body><B>openOnShell: aShell 
	</B>^self
		openOn: (self instanceFor: aShell)
		withSpec: (self viewFor: aShell)</body>

<body><B>viewFor: aShell 
	</B>"Answer the windowSpec for aShell. 
	NOTE: This currently doesn't respect the Shell&gt;defaultView."

	^(aShell class name , 'WindowSpec') asSymbol</body>
</methods>

<methods>
<class-id>ShellView class</class-id> <category>resources</category>

<body>QLauncherMenuBar
	"MenuEditor new openOnClass: self andSelector: #QLauncherMenuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 'System' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 'New project' 
							#value: #newProject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Open project...' 
							#value: #openProject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Save project' 
							#value: #saveProject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Save project as...' 
							#value: #saveProjectAs ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Exit' 
							#value: #exitSmalltalk ) ) #(4 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 'Tools' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 'Class browser' 
							#value: #openClassBrowser ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Workspace' 
							#value: #openWorkspace ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Package browser' 
							#value: #openPackageBrowser ) ) #(3 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 'Search' ) 
			#(#{UI.MenuItem} 
				#rawLabel: 'Options' ) ) #(4 ) nil ) decodeAsLiteralArray</body>

<body><B>QWorkspaceMenuBar
	</B>"MenuEditor new openOnClass: self andSelector: #QWorkspaceMenuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 'Source' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 'Accept' 
							#value: #accept 
							#shortcutKeyCharacter: $S ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Cut' 
							#value: #cutSelection 
							#shortcutKeyCharacter: $X ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Do it' 
							#value: #doIt 
							#shortcutKeyCharacter: $X ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Print it' 
							#value: #printIt 
							#shortcutKeyCharacter: $P ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Inspect it' 
							#value: #inspectIt 
							#shortcutKeyCharacter: $I ) ) #(1 1 3 ) nil ) ) ) #(1 ) nil ) decodeAsLiteralArray</body>
</methods>

<methods>
<class-id>ShellView class</class-id> <category>interface specs</category>

<body><B>QLauncherWindowSpec
	</B>"UIPainter new openOnClass: self andSelector: #QLauncherWindowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Pocket Smalltalk' 
			#min: #(#{Core.Point} 363 45 ) 
			#max: #(#{Core.Point} 363 45 ) 
			#bounds: #(#{Graphics.Rectangle} 29 411 392 456 ) 
			#flags: 4 
			#menu: #QLauncherMenuBar )
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #() ) )</body>

<body><B>QWorkspaceWindowSpec
	</B>"UIPainter new openOnClass: self andSelector: #QWorkspaceWindowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Workspace' 
			#bounds: #(#{Graphics.Rectangle} 154 195 354 395 ) 
			#flags: 4 
			#menu: #QWorkspaceMenuBar
			#performer: #menuBarPerformer ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.TextEditorSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 -25 1 ) 
					#name: #sourceCode 
					#style: #system 
					#tabRequiresControl: true ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 -25 1 0 1 0 1 ) 
					#name: #status 
					#isReadOnly: true ) ) ) )</body>
</methods>

<methods>
<class-id>ShellView</class-id> <category>VW</category>

<body><B>postBuildWith: aBuilder 
	</B>super postBuildWith: aBuilder.
	shell notNil ifTrue: [builder windowSpec performer: shell]</body>

<body><B>requestForWindowClose
	</B>| valueHolder |
	valueHolder := true asValue.
	shell trigger: #closeRequested: with: valueHolder.
	^valueHolder value</body>

<body><B>setShell: aShell 
	</B>shell := aShell</body>
</methods>

<methods>
<class-id>ShellView</class-id> <category>API</category>

<body><B>caption
	</B>^builder window label</body>

<body><B>caption: aString 
	</B>builder window label: aString</body>
</methods>


<methods>
<class-id>Core.Symbol</class-id> <category>system primitives</category>

<body><B>argumentCount
	</B>"Dolphin has a different name for this method."

	^self numArgs</body>
</methods>


<methods>
<class-id>Core.Character</class-id> <category>testing</category>

<body><B>isControl
	</B>"Answer whether the receiver is an ascii control character."

	^self asInteger &lt; 32</body>

<body><B>isHexDigit
	</B>"Answer whether the receiver is a hexadecimal digit."

	^self isDigit or: [self between: $A and: $F]</body>

<body><B>isPunctuation
	</B>"Answer whether the receiver is a hexadecimal digit."

	^'!"#$%&amp;''()*+,-./:;&lt;=&gt;?@[\]^_`{|}~' "and more..." includes: self</body>
</methods>


<methods>
<class-id>Core.Character class</class-id> <category>accessing untypeable characters</category>

<body><B>null
</B>	"Answer the Character representing \0."

	^self value: <B>0</B></body>
</methods>


<reorganize>
<class-id>QChangeLog class</class-id> <organization>('No category')
('accessing' #current #reset)
</organization>
</reorganize>

<methods>
<class-id>Core.Behavior</class-id> <category>accessing instances and variables</category>

<body><B>allSubinstances
	</B>"Answer a collection of all instances of this class and all instances of all subclasses."

	| oc |
	oc := OrderedCollection new.
	self withAllSubclasses do: [:each | oc addAll: each allInstances].
	^oc</body>
</methods>


<methods>
<class-id>File class</class-id> <category>No category</category>

<body><B>find: aString 
	</B>"File find: '*.*'"

	^(aString asFilename directory filenamesMatching: aString) 
		collect:[:each | Pretender new answer: [each tail] on: #fileName]</body>

<body><B>splitPathFrom: aString 
	</B>"File splitPathFrom: 'C:\windows\win.com'"

	^aString asFilename head copyWith: Filename separator</body>
</methods>


<methods>
<class-id>Shell</class-id> <category>adding</category>

<body><B>add: aPresenter name: aString </B>
	aPresenter parentPresenter: self.<B>
	</B>^presenters at: aString put: aPresenter</body>
</methods>

<methods>
<class-id>Shell</class-id> <category>actions</category>

<body><B>exit
	</B>uibuilder window model closeRequest</body>
</methods>

<methods>
<class-id>Shell</class-id> <category>initialization</category>

<body><B>initialize
	</B>super initialize.
	presenters := Dictionary new</body>
</methods>

<methods>
<class-id>Shell</class-id> <category>VW</category>

<body><B>myShell
	</B>^self</body>

<body><B>openView
	</B>self createComponents.
	self createSchematicWiring.
	uibuilder := ShellView openOnShell: self</body>

<body><B>widgetFor: aPresenter 
	</B>| name |
	name := presenters keyAtValue: aPresenter.
	^uibuilder componentAt: name asSymbol</body>
</methods>


<reorganize>
<class-id>Shell</class-id> <organization>('adding' #add:name:)
('actions' #exit)
('initialization' #initialize)
('VW' #myShell #openView #widgetFor:)
</organization>
</reorganize>

<methods>
<class-id>Shell class</class-id> <category>API</category>

<body><B>show
	</B>"Create a new instance of the receiver and display it in a toplevel - so call shell - window."

	^self new openView</body>
</methods>


<reorganize>
<class-id>Shell class</class-id> <organization>('API' #show)
</organization>
</reorganize>

<methods>
<class-id>RichTextPresenter</class-id> <category>accessing</category>

<body><B>view
	</B>"Answer the receiver's view with the intension to set its font."

	^Pretender new 
		doNothingOn: #font:;
		answer: [| c |
			c := self vwWidget widget controller.
			c selectionStartIndex to: c selectionStopIndex - 1]
		on: #selectionRange;

		answer: [self vwWidget widget controller text asString]
		on: #plainText</body>
</methods>


<reorganize>
<class-id>RichTextPresenter</class-id> <organization>('accessing' #view)
</organization>
</reorganize>

<methods>
<class-id>Pretender</class-id> <category>error handling</category>

<body><B>doesNotUnderstand: aMessage 
	</B>| answer |
	answer := answers
		at: aMessage selector
		ifAbsent: [^super doesNotUnderstand: aMessage].
	^(answer isKindOf: [] class)
		ifTrue: [self callBlock: answer with: aMessage arguments]
		ifFalse: [answer]</body>
</methods>

<methods>
<class-id>Pretender</class-id> <category>initialization</category>

<body><B>answer: answer on: selector 
	</B>answers isNil ifTrue: [answers := Dictionary new].
	answers at: selector put: answer</body>

<body><B>doNothingOn: selector 
	</B>self answer: [self] on: selector</body>
</methods>

<methods>
<class-id>Pretender</class-id> <category>private</category>

<body><B>callBlock: block with: arguments 
	</B>| args numArgs |
	args := arguments.
	numArgs := block numArgs.
	args size &gt; numArgs
		ifTrue: [args := args copyFrom: 1 to: numArgs]
		ifFalse: [[args size &lt; numArgs] whileTrue: [args copyWith: nil]].
	^block valueWithArguments: args</body>
</methods>


<methods>
<class-id>QClassLibrary class</class-id> <category>VW</category>

<body><B>eventsTriggered
	</B>^#(#addedMethod:to: #removedMethod:from: #checkpoint)</body>
</methods>


<reorganize>
<class-id>QClassLibrary class</class-id> <organization>('No category')
('accessing' #current)
('VW' #eventsTriggered)
</organization>
</reorganize>


</st-source>
