<?xml version="1.0"?>

<st-source>
<!-- Changes in change set dolphin-compat2 -->
<time-stamp>From VisualWorks® NonCommercial, Release 5i.2 of July 14, 2000 on December 8, 2000 at 3:19:51 pm</time-stamp>


<class>
<name>Font</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>ListPrompter</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>TimeStamp</name>
<environment>Smalltalk</environment>
<super>Core.Timestamp</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>FileDialog</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>fileTypes caption defaultExtension value </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>FileOpenDialog</name>
<environment>Smalltalk</environment>
<super>FileDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>MessageBox</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>Prompter</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>SessionManager</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars>current </class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>FileStream</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>File</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>STBInFiler</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>FileSaveDialog</name>
<environment>Smalltalk</environment>
<super>FileDialog</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>STBOutFiler</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<methods>
<class-id>Font class</class-id> <category>No category</category>

<body><B>choose
	</B>self halt: 'not implemented yet'</body>
</methods>


<methods>
<class-id>ListPrompter class</class-id> <category>No category</category>

<body><B>list: names caption: caption 
	</B>^self on: '' list: names caption: caption</body>

<body><B>on: answer list: names caption: caption 
	</B>"ListPrompter on: 'sma' list: #('abc' 'sma' 'xyz') caption: 'Choose!'"

	^Dialog
		choose: caption
		fromList: names
		values: names
		lines: (names size max: 16)
		cancel: [nil]</body>
</methods>


<methods>
<class-id>TimeStamp class</class-id> <category>No category</category>

<body><B>current
	</B>^self now</body>
</methods>


<methods>
<class-id>FileDialog class</class-id> <category>No category</category>

<body><B>allFilesType
	</B>^#('All Files (*.*)' '*.*')</body>

<body><B>new
	</B>^super new initialize</body>

<body><B>on: valueModel 
	</B>^self new value: valueModel value</body>
</methods>

<methods>
<class-id>FileDialog</class-id> <category>No category</category>

<body><B>caption: aString 
	</B>caption := aString</body>

<body><B>default
	</B>value isNil ifTrue: [^'*.' , defaultExtension].
	(value includes: $.)<B> </B>ifTrue: [^value].
	^value , '.' , defaultExtension</body>

<body><B>defaultCaption
	</B>self subclassResponsibility</body>

<body><B>defaultExtension: aString 
	</B>defaultExtension := aString</body>

<body><B>fileTypes: anArray 
	</B>fileTypes := anArray</body>

<body><B>initialize
	</B>caption := self defaultCaption.
	defaultExtension := '*'</body>

<body><B>showModal
	</B>self subclassResponsibility</body>

<body><B>value: aString 
	</B>value := aString</body>
</methods>


<methods>
<class-id>FileDialog class</class-id> <category>No category</category>

<body><B>new
	</B>^super new initialize</body>

<body><B>on: valueModel 
	</B>^self new value: valueModel value</body>
</methods>


<methods>
<class-id>FileOpenDialog</class-id> <category>No category</category>

<body><B>defaultCaption
	</B>^'Open a file'</body>

<body><B>showModal
	</B>^Dialog requestFileName: caption default: self default</body>
</methods>


<remove-selector>
<class-id>FileOpenDialog class</class-id> <selector>on:</selector>
</remove-selector>

<remove-selector>
<class-id>FileOpenDialog class</class-id> <selector>new</selector>
</remove-selector>

<methods>
<class-id>MessageBox class</class-id> <category>No category</category>

<body><B>confirm: aString 
	</B>^Dialog confirm: aString</body>

<body><B>notify: aString 
	</B>Dialog warn: aString</body>
</methods>


<methods>
<class-id>Prompter class</class-id> <category>No category</category>

<body><B>on: answer prompt: prompt caption: caption 
	</B>^Dialog
		request: caption , (String with: Character cr) , prompt
		initialAnswer: answer
		onCancel: [nil]</body>

<body><B>prompt: prompt caption: caption 
	</B>^self<B> </B>on: ''<B> </B>prompt: prompt<B> </B>caption: caption</body>
</methods>


<methods>
<class-id>SessionManager class</class-id> <category>No category</category>

<body><B>current
	</B>current isNil ifTrue: [current := self new].
	^current</body>
</methods>

<methods>
<class-id>SessionManager</class-id> <category>No category</category>

<body><B>exit
	</B>"Exit image without asking!"

	ObjectMemory quit</body>

<body><B>imageBase
	</B>^Filename defaultDirectoryName , (String with: Filename separator)</body>
</methods>


<methods>
<class-id>FileStream class</class-id> <category>No category</category>

<body><B>read: filename 
	</B>^filename asFilename readStream</body>

<body><B>read: filename text: boolean 
	</B>^boolean
		ifTrue: [(self read: filename) text]
		ifFalse: [(self read: filename) binary]</body>

<body><B>write: filename 
	</B>^self write: filename mode: #normal</body>

<body><B>write: filename mode: mode 
	</B>mode == #append ifTrue: [^filename asFilename appendStream].
	^filename asFilename writeStream</body>

<body><B>write: filename text: boolean 
	</B>^boolean
		ifTrue: [(self write: filename) text]
		ifFalse: [(self write: filename) binary]</body>
</methods>


<methods>
<class-id>File class</class-id> <category>No category</category>

<body>exists: aString
	^aString asFilename exists</body>

<body><B>find: aString 
	</B>"File find: '*.*'"

	^(aString asFilename directory filesMatching: aString)
		halt: 'needs to be something that understands #fileName'</body>

<body><B>splitExtensionFrom: aString 
	</B>"File splitExtensionFrom: 'C:\windows\win.com'"

	^aString asFilename extension copyWithout: $.</body>

<body><B>splitFilenameFrom: aString 
	</B>"File splitFilenameFrom: 'C:\windows\win.com'"

	^aString asFilename tail</body>

<body><B>splitPathFrom: aString 
	</B>"File splitPathFrom: 'C:\windows\win.com'"

	^aString asFilename head</body>

<body><B>splitStemFrom: aString 
	</B>"File splitStemFrom: 'C:\windows\win.com'"

	| n index |
	n := self splitFilenameFrom: aString.
	^(index := n lastIndexOf: $.) = 0
		ifTrue: [n]
		ifFalse: [n copyFrom: 1 to: index - 1]</body>
</methods>


<methods>
<class-id>STBInFiler class</class-id> <category>No category</category>

<body><B>on: aStream 
	</B>"Use a BOSS reader instead of a Dolphin Smalltalk STBInFiler. 
	This is a different, incompatible, format but at least we can store things."

	^BinaryObjectStorage onOld: aStream</body>
</methods>


<methods>
<class-id>STBInFiler class</class-id> <category>No category</category>

<body><B>on: aStream 
	</B>"Use a BOSS reader instead of a Dolphin Smalltalk STBInFiler. 
	This is a different, incompatible, format but at least we can store things."

	^BinaryObjectStorage onOld: aStream</body>
</methods>


<methods>
<class-id>FileSaveDialog</class-id> <category>No category</category>

<body><B>defaultCaption
	</B>^'Save a file'</body>

<body><B>showModal
	</B>^Dialog requestNewFileName: caption default: self default</body>
</methods>


<methods>
<class-id>STBOutFiler class</class-id> <category>No category</category>

<body><B>on: aStream 
	</B>"Use a BOSS writer instead of a Dolphin Smalltalk STBOutFiler. 
	This is a different, incompatible, format but at least we can store things."

	^BinaryObjectStorage onNew: aStream</body>
</methods>



</st-source>
