<?xml version="1.0"?>

<st-source>
<!-- Changes in change set dolphin-compat4 -->
<time-stamp>From VisualWorks® NonCommercial, Release 5i.2 of July 14, 2000 on December 9, 2000 at 9:24:05 am</time-stamp>


<class>
<name>Presenter</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>events parentPresenter model </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>ListPresenter</name>
<environment>Smalltalk</environment>
<super>Presenter</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<class>
<name>StatusItem</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>model </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Compatibility</category>
</class>

<methods>
<class-id>ShellView</class-id> <category>VW</category>

<body>vwTab1
	shell vwTab: 1</body>

<body><B>vwTab2
	</B>shell vwTab: 2</body>

<body><B>vwTab3
	</B>shell vwTab: 3</body>
</methods>


<remove-selector>
<class-id>ShellView</class-id> <selector>caption:</selector>
</remove-selector>

<remove-selector>
<class-id>ShellView</class-id> <selector>caption</selector>
</remove-selector>

<reorganize>
<class-id>ShellView</class-id> <organization>('VW' #postBuildWith: #requestForWindowClose #setShell: #vwTab1 #vwTab2 #vwTab3)
</organization>
</reorganize>

<methods>
<class-id>ShellView class</class-id> <category>resources</category>

<body>QLauncherMenuBar
	"MenuEditor new openOnClass: self andSelector: #QLauncherMenuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 'System' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 'New project' 
							#value: #newProject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Open project...' 
							#value: #openProject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Save project' 
							#value: #saveProject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Save project as...' 
							#value: #saveProjectAs ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Exit' 
							#value: #exitSmalltalk ) ) #(4 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 'Tools' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 'Class browser' 
							#value: #openClassBrowser ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Package browser' 
							#value: #openPackageBrowser ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Workspace' 
							#value: #openWorkspace ) ) #(3 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 'Search' ) 
			#(#{UI.MenuItem} 
				#rawLabel: 'Options' ) ) #(4 ) nil ) decodeAsLiteralArray</body>

<body>QPackageBrowserMenuBar
	"MenuEditor new openOnClass: self andSelector: #QPackageBrowserMenuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 'Package' 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 'New package' 
							#value: #newPackage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Install package...' 
							#value: #installPackage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Save package' 
							#value: #savePackage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Save package as...' 
							#value: #savePackageAs ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Set as default' 
							#value: #setSelectedPackageAsDefault ) 
						#(#{UI.MenuItem} 
							#rawLabel: 'Move to front' 
							#value: #moveSelectedPackageToFront ) ) #(4 2 ) nil ) ) ) #(1 ) nil ) decodeAsLiteralArray</body>
</methods>

<methods>
<class-id>ShellView class</class-id> <category>interface specs</category>

<body>QPackageBrowserWindowSpec
	"UIPainter new openOnClass: self andSelector: #QPackageBrowserWindowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Package Browser' 
			#bounds: #(#{Graphics.Rectangle} 309 204 715 565 ) 
			#flags: 4 
			#menu: #QPackageBrowserMenuBar ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.SequenceViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 -1 0.4 ) 
					#name: #packageList 
					#style: #system 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#{UI.SequenceViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 26 0.4 0 1 0 1 ) 
					#name: #classList 
					#style: #system 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0.4 50 0 25 0.4 ) 
					#model: #vwTab1 
					#label: 'Classes' 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} 50 0 0 0.4 100 0 25 0.4 ) 
					#model: #vwTab2 
					#label: 'Methods' 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} 100 0 0 0.4 150 0 25 0.4 ) 
					#model: #vwTab3 
					#label: 'Consts' 
					#defaultable: true ) 
				#(#{UI.SequenceViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 26 0.4 0 1 0 1 ) 
					#name: #methodList 
					#flags: 29 
					#style: #system 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#{UI.SequenceViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 26 0.4 0 1 0 1 ) 
					#name: #constantList 
					#flags: 29 
					#style: #system 
					#useModifierKeys: true 
					#selectionType: #highlight ) ) ) )</body>
</methods>


<methods>
<class-id>FileDialog</class-id> <category>No category</category>

<body><B>allFilesType
	</B>^self class allFilesType</body>

<body><B>default</B>
	| v |
	v := value value.<B>
	</B>v isNil ifTrue: [^'*.' , defaultExtension].
	(v includes: $.) ifTrue: [^v].
	^v , '.' , defaultExtension</body>

<body><B>value: valueModel 
	</B>value := valueModel</body>
</methods>


<methods>
<class-id>FileDialog class</class-id> <category>No category</category>

<body><B>on: valueModel 
	</B>^self new value: valueModel</body>
</methods>


<methods>
<class-id>Presenter</class-id> <category>accessing</category>

<body><B>model
	</B>^model</body>

<body><B>model: aModel 
	</B>model := aModel</body>
</methods>

<methods>
<class-id>Presenter</class-id> <category>initialization</category>

<body><B>initialize
	</B>model := self class defaultModel</body>
</methods>

<methods>
<class-id>Presenter</class-id> <category>VW</category>

<body><B>myShell
	</B>"Answer the presenter's shell."

	^self parentPresenter myShell</body>

<body><B>vwWidget
	</B>"Answer the receiver's corresponding widget."

	^self myShell widgetFor: self</body>
</methods>


<remove-selector>
<class-id>Presenter</class-id> <selector>createSchematicWiring</selector>
</remove-selector>

<remove-selector>
<class-id>Presenter</class-id> <selector>createComponents</selector>
</remove-selector>

<methods>
<class-id>ListPresenter class</class-id> <category>No category</category>

<body><B>eventsTriggered
	</B>^#(#selectionChanged #actionPerformed)</body>
</methods>

<methods>
<class-id>ListPresenter</class-id> <category>accessing</category>

<body><B>list
	</B>^self vwWidget model value</body>

<body><B>list: collection 
	</B>self vwWidget model value: collection asList</body>

<body><B>selection: anObject 
	</B>self vwWidget selectionIndex: (self vwWidget sequence indexOf: anObject)</body>

<body><B>selectionOrNil
	</B>^self vwWidget selection</body>

<body><B>view
	</B>"Ignore #getTextBlock: setter for now."

	^Pretender new doNothingOn: #getTextBlock:</body>
</methods>

<methods>
<class-id>ListPresenter</class-id> <category>VW</category>

<body><B>connectToView
	</B>"Connect VW specific listeners to the receiver's associated widget<B>
	</B>and translate them to Dolphin-conform events."

	| w d |
	w := self vwWidget.	"w model onChangeSend: #vwListChanged to: self."
	w selectionChannel onChangeSend: #vwSelectionChanged to: self.
	d := UIDispatcher new doubleClickSelector: #vwActionPerformed receiver: self.
	w controller setDispatcher: d</body>

<body><B>vwActionPerformed
	</B>self trigger: #actionPerformed</body>

<body><B>vwSelectionChanged
	</B>self trigger: #selectionChanged</body>
</methods>


<methods>
<class-id>Core.Collection</class-id> <category>testing</category>

<body><B>allSatisfy: aBlock 
</B>	"Answer whether all elements of the receiver will evaluate aBlock to true."
<B>
	</B>self do: [:each | (aBlock value: each)<B> </B>ifFalse: [^false]].
	^true</body>

<body><B>anySatisfy: aBlock </B>
	"Answer whether at least one element of the receiver will evaluate aBlock to true."
<B>
	</B>self do: [:each | (aBlock value: each) ifTrue: [^true]].
	^false</body>

<body><B>notEmpty
	</B>"Answer whether the receiver contains any elements."

	^self isEmpty not</body>
</methods>


<methods>
<class-id>StatusItem</class-id> <category>accessing</category>

<body><B>getImageBlock: aBlock 
	</B>"ignore"</body>

<body><B>model
	</B>^model</body>

<body><B>model: aModel 
	</B>model := aModel</body>
</methods>


<methods>
<class-id>Shell</class-id> <category>accessing</category>

<body><B>caption
	</B>^uibuilder window label</body>

<body><B>caption: aString 
	</B>uibuilder window label: aString</body>

<body><B>subPresenters
	</B>^presenters values</body>
</methods>

<methods>
<class-id>Shell</class-id> <category>actions</category>

<body><B>exit
	</B>uibuilder window model closeRequest</body>
</methods>

<methods>
<class-id>Shell</class-id> <category>initialization</category>

<body><B>createComponents
	</B>"Make named presenters known to the receiver."</body>

<body><B>createSchematicWiring
	</B>"Connect other presenters to the receiver."</body>
</methods>

<methods>
<class-id>Shell</class-id> <category>VW</category>

<body><B>myShell
	</B>"Answer the presenter's shell - wait, that's me!"

	^self</body>

<body><B>openView
	</B>"Initialize the receiver (should probably done earlier) 
	and setup the VW view and connect that objects to the presenters."

	uibuilder := ShellView openOnShell: self.
	self createComponents.
	self createSchematicWiring.
	self subPresenters do: [:p | p connectToView]</body>

<body>view
	"Try to work around statusbar initialization in QPackageBrowser"

	^Pretender new
		answer: [Pretender new
			answer: [Pretender new
				doNothingOn: #addItem:
			]
			on: #viewNamed:
		]
		on: #view</body>

<body><B>widgetFor: aPresenter 
	</B>| name |
	name := presenters keyAtValue: aPresenter.
	^(uibuilder componentAt: name asSymbol) widget</body>
</methods>


<reorganize>
<class-id>Shell</class-id> <organization>('accessing' #caption #caption: #subPresenters)
('actions' #exit)
('adding' #add:name:)
('initialization' #createComponents #createSchematicWiring #initialize)
('VW' #myShell #openView #view #widgetFor:)
</organization>
</reorganize>

<methods>
<class-id>QPackageBrowser</class-id> <category>No category</category>

<body><B>view
	</B>"Try to work around statusbar initialization."

	^Pretender new
		answer: [Pretender new 
			answer: [:item | item]
			on: #addItem:]
		on: #viewNamed:</body>

<body><B>vwTab: nr 
	</B>"This method implements a cheap TabbedPane widget. See also #vwTabs."

	| index |
	index := 0.
	self vwTabs do: [:each | (uibuilder componentAt: each)
			isVisible: nr = (index := index + 1)]</body>

<body><B>vwTabs
	</B>^#(#classList #methodList #constantList)</body>
</methods>


<methods>
<class-id>QPackageLibrary class</class-id> <category>No category</category>

<body><B>eventsTriggered
	</B>^#(#changed #defaultPackageChanged #classesChangedFor: #methodsChangedFor: #constantsChangedFor:)</body>
</methods>


<methods>
<class-id>Core.OrderedCollection</class-id> <category>adding</category>

<body><B>add: anObject afterIndex: spot 
	</B>"Strangly, this method was missing in VisualWorks."

	^self add: anObject beforeIndex: spot + 1</body>
</methods>


<reorganize>
<class-id>UI.SelectionView</class-id> <organization>('initialize-release' #initialize #initializeGrid #initializeSelectionChannel #release #scrollOffsetHolder:)
('accessing' #displayStringAt: #displayStringSelector #displayStringSelector: #getTextStyle #lastSelectionIndex #lineGrid #lineGrid: #model: #selectionChannel #selectionChannel: #selectionIndex #selectionIndex: #sequence #sequence: #targetIndex #targetIndex: #textStyle #textStyle: #zeroIndex)
('constants' #leftOffsetForDisplay #topOffsetForDisplay)
('focus accessing' #desiresFocus #hasFocus #hasFocus: #loseFocus #takeFocus)
('updating' #dynamicUpdatingOfSelection #update:with:from: #updateAdd: #updateAppendCollection: #updateAt: #updateInsert: #updateInsertCollection: #updateModel #updateRemove: #updateRemoveRange: #updateReplace: #updateSelectionChannel)
('private' #elementsInSequenceHaveChanged #firstIndex #getDefaultTextStyle #initialSelectionIndex #isSelected: #isValidIndex: #lastIndex #makeVisible: #newElementsFrom:to: #redisplayForEnabledChange #resetSelection #retractSelectionIndex: #setSelectionIndex: #setTextStyle: #setValidTargetIndex: #useSelectionIndex:)
('drag and drop' #showDropFeedbackIn:allowScrolling:)
('event driven' #selection)
('AHSWHC adds' #ahsActivityPoint)
('element accessing' #boundsOfElementIndex:inBounds: #elementIndexFor: #invalidateElementIndex: #numberOfElements)
</organization>
</reorganize>

<methods>
<class-id>RichTextPresenter</class-id> <category>accessing</category>

<body><B>view
	</B>"Answer the receiver's view with the intension to set its font."

	^Pretender new 
		doNothingOn: #font:;
		answer: [| c |
			c := self vwWidget controller.
			c selectionStartIndex to: c selectionStopIndex - 1]
		on: #selectionRange;

		answer: [self vwWidget controller text asString]
		on: #plainText</body>
</methods>

<methods>
<class-id>RichTextPresenter</class-id> <category>VW</category>

<body><B>connectToView</B></body>
</methods>


<reorganize>
<class-id>RichTextPresenter</class-id> <organization>('accessing' #view)
('VW' #connectToView)
</organization>
</reorganize>


</st-source>
