<?xml version="1.0"?>

<st-source>
<!-- Changes in change set dolphin-filein -->
<time-stamp>From VisualWorks® NonCommercial, Release 5i.2 of July 14, 2000 on December 8, 2000 at 1:25:12 pm</time-stamp>


<class>
<name>DolphinCategoryReader</name>
<environment>Smalltalk</environment>
<super>Core.Object</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>class category </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Dolphin-Filein</category>
</class>

<methods>
<class-id>Core.ClassDescription</class-id> <category>fileIn/Out</category>

<body>categoriesFor: aSymbol
	"Answer a DolphinCategoryReader for reading in method categories."

	^DolphinCategoryReader class: self category: aSymbol</body>

<body>categoriesForClass
	"Answer a DolphinCategoryReader for reading in (actually ignoring) class categories."

	^DolphinCategoryReader class: self category: nil</body>

<body>methodsFor
	^self methodsFor: 'No category'</body>
</methods>


<methods>
<class-id>Core.UndefinedObject class</class-id> <category>fileIn/Out</category>

<body>methodsFor
	^self methodsForUndefined: 'No category'</body>
</methods>


<methods>
<class-id>DolphinCategoryReader class</class-id> <category>instance creation</category>

<body>class: aClass category: aSymbol
	^self new setClass: aClass category: aSymbol</body>
</methods>

<methods>
<class-id>DolphinCategoryReader</class-id> <category>fileIn/Out</category>

<body>scanFrom: aStream using: aFormatter
	| string |
	[(string := aFormatter methodBodyFrom: aStream) size &gt; 0]
		whileTrue: [self process: string]</body>
</methods>

<methods>
<class-id>DolphinCategoryReader</class-id> <category>private</category>

<body><B>process: aString
	</B>category isNil 
		ifTrue: [Smalltalk organization classify: class name under: 'PST-Core']
		ifFalse: [class organization classify: category under: aString]</body>

<body>setClass: aClass category: aSymbol
	class := aClass.
	category := aSymbol</body>
</methods>



</st-source>
